<template>
    <div>
        <div class="tool-tip-flex">
            <el-tooltip effect="dark" placement="top-start">
                <el-icon size="large"><InfoFilled /></el-icon>
                <template #content>
                    {{ t("global.infoElements") }}
                </template>
            </el-tooltip>
            <el-text type="info">
                {{t("global.titreElement")}}
            </el-text>
        </div>
        <el-collapse v-model="activeNames" accordion v-if="grille.element.length > 0">
            <ElementComp v-for="(element, index) of grille.element" :element="element" :index="index" :key="index"
                         @delete-critere="(critereIndex: number) => deleteCritere(critereIndex, index)"
                         @add-critere="(content: string) => addCritere(content, index)"
                         @add-bareme="addBareme" @delete-bareme="(baremeIndex: number) => deleteBareme(baremeIndex, index)"
                         @update-bareme-content="(baremeIndex: number, content:string) => updateBaremeContent(index, baremeIndex, content)"
                         @update-bareme-min-value="(value: number|null, baremeIndex: number) => updateBaremeMinValue(value, baremeIndex, index)"
                         @update-bareme-max-value="(value: number, baremeIndex: number) => updateBaremeMaxValue(value, baremeIndex, index)"
                         @delete-comment="(commentIndex: number) => deleteComment(commentIndex, index)"
                         @add-comment="(content: string) => addComment(content, index)"
                         @update-element-title="updateElementTitle"
                         @update-element-weigth="updateElementWeigth"
                         @delete-element="deleteElement"
                         @update-bareme-title="(content: string, baremeIndex: number) => updateBaremeTitle(content, baremeIndex, index)"/>
        </el-collapse>
        <div class="no-element-block" v-else>
            Aucun Elements
        </div>
        <el-button class="add-element-btn" type="success" @click="addElement"><el-icon style="margin: 0 5px 0 0"><Plus /></el-icon>{{t("global.addElement")}}</el-button>
    </div>
</template>

<script lang="ts" setup>
    import { ref, computed } from 'vue';
    import {useI18n} from "vue3-i18n"
    import { Grille } from '@/types/entities/creation-grille/Grille';
    import ElementComp from '@/components/creation-grille/ElementComponent.vue';

    import { Plus } from '@element-plus/icons-vue';
    import { InfoFilled } from '@element-plus/icons-vue';

    const { t } = useI18n()

    // eslint-disable-next-line
    defineProps<{
        grille: Grille,
    }>();

    console

    // eslint-disable-next-line
    const emit = defineEmits(['deleteCritere', 'addCritere', 'addBareme', 'deleteBareme', 'updateBaremeContent',
    'updateBaremeMaxValue', 'updateBaremeMinValue', 'deleteComment', 'addComment', 'updateElementTitle', 'updateElementWeigth', 'addElement', 'deleteElement', 'updateBaremeTitle'])

    const activeNames = ref([0]);

    // Gestion Critere

    const addCritere = (content: string, index: number) => {
        emit('addCritere', content, index)
    }
    const deleteCritere = (critereIndex: number, index: number) => {
        emit('deleteCritere', critereIndex, index)
    }

    // Gestion Element
    const updateElementTitle = (content: string, elementIndex: number) => {
        emit('updateElementTitle', content, elementIndex)
    }

    const updateElementWeigth = (value: number, elementIndex: number) => {
        emit('updateElementWeigth', value, elementIndex)
    }

    const addElement = () => {
        emit('addElement')
    }

    const deleteElement = (elementIndex: number) => {
        emit('deleteElement', elementIndex)
    }

    // Gestion Baremes

    const addBareme = (index: number) => {
        emit('addBareme', index)
    }
    const deleteBareme = (baremeIndex: number, elementIndex: number) => {
        emit('deleteBareme', baremeIndex, elementIndex)
    }
    const updateBaremeContent = (elementIndex: number, baremeIndex: number, content:string) => {
        emit('updateBaremeContent', elementIndex, baremeIndex, content)
    }
    const updateBaremeMaxValue = (value: number, baremeIndex:number, index:number) => {
        emit('updateBaremeMaxValue', value, baremeIndex, index)
    }
    const updateBaremeMinValue = (value: number|null, baremeIndex:number, index:number) => {
        emit('updateBaremeMinValue', value, baremeIndex, index)
    }
    const updateBaremeTitle = (content: string, baremeIndex: number, elementIndex: number)=> {
        emit('updateBaremeTitle', content, baremeIndex, elementIndex);
    }

    // Gestion Commentaires

    const addComment = (content: string, index: number) => {
        emit('addComment', content, index)
    }
    const deleteComment = (commentIndex: number, index: number) => {
        emit('deleteComment', commentIndex, index)
    }
    
    
</script>
<style scoped>
    .tool-tip-flex {
        display: flex;
        align-content: center;
        gap: 5px;   
    }
    .add-element-btn {
        width: 100%;
        margin: 5px 0 5px 0;
    }
    .no-element-block{
        width: 100%;
        padding: 25px;
        margin: 5px 0;
        text-align: center;
        border: 2px dotted lightgrey;
        color: grey;
    }
</style>
